import {
  ListboxKbNavController,
  unwrap
} from "./chunk.2X23R32H.js";
import {
  TransitionalStyles
} from "./chunk.FRKST3V3.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet
} from "./chunk.5VURDMKE.js";

// libs/core/src/primitives/menu/menu.ts
import { createRef, ref } from "lit/directives/ref.js";
var _slotRef;
var GdsMenu = class extends GdsElement {
  constructor() {
    super();
    __privateAdd(this, _slotRef, createRef());
    new ListboxKbNavController(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "menu");
    TransitionalStyles.instance.apply(this, "gds-listbox");
  }
  get navigableItems() {
    if (!__privateGet(this, _slotRef).value)
      return [];
    return unwrap(__privateGet(this, _slotRef).value).assignedElements().filter(
      (o) => !o.hasAttribute("isplaceholder") && o.gdsElementName === "gds-menu-item"
    ) || [];
  }
  /**
   * Focuses the first item in the menu.
   */
  focus() {
    var _a;
    (_a = this.navigableItems[0]) == null ? void 0 : _a.focus();
  }
  render() {
    return html`<slot ${ref(__privateGet(this, _slotRef))}></slot>`;
  }
};
_slotRef = new WeakMap();
GdsMenu = __decorateClass([
  gdsCustomElement("gds-menu")
], GdsMenu);

export {
  GdsMenu
};
