import {
  img_style_css_default
} from "./chunk.NKSKWGNM.js";
import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.67V2EUAS.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/media/img/img.ts
import { property } from "lit/decorators.js";
var GdsImg = class extends GdsElement {
  render() {
    return html`<figure><img src="${this.src}" alt="${this.alt}" /></figure>`;
  }
};
GdsImg.styles = [tokens, img_style_css_default];
__decorateClass([
  styleExpressionProperty({
    property: "aspect-ratio",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "ratio", 2);
__decorateClass([
  styleExpressionProperty({
    property: "object-position",
    selector: "img",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "position", 2);
__decorateClass([
  styleExpressionProperty({
    property: "inset",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "inset", 2);
__decorateClass([
  styleExpressionProperty({
    property: "width",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "width", 2);
__decorateClass([
  styleExpressionProperty({
    property: "height",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "height", 2);
__decorateClass([
  styleExpressionProperty({
    property: "opacity",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty({
    property: "object-fit",
    selector: "img",
    valueTemplate: (v) => v
  })
], GdsImg.prototype, "fit", 2);
__decorateClass([
  property()
], GdsImg.prototype, "src", 2);
__decorateClass([
  property()
], GdsImg.prototype, "alt", 2);
__decorateClass([
  styleExpressionProperty({
    property: "border-radius",
    selector: "figure",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsImg.prototype, "radius", 2);
GdsImg = __decorateClass([
  gdsCustomElement("gds-img")
], GdsImg);

export {
  GdsImg
};
